#pragma once

/* Generated with cbindgen:0.26.0 */

/* DO NOT MODIFY THIS MANUALLY */

#include <stdarg.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

#define KimeKIME_API_VERSION 7

typedef enum KimeIconColor {
  White,
  Black,
} KimeIconColor;

enum KimeInputCategory {
  Latin,
  Hangul,
};
typedef uint32_t KimeInputCategory;

/**
 * Preprocessed engine config
 */
typedef struct KimeConfig KimeConfig;

typedef struct KimeDaemonConfig KimeDaemonConfig;

typedef struct KimeIndicatorConfig KimeIndicatorConfig;

typedef struct KimeInputEngine KimeInputEngine;

typedef struct KimeLogConfig KimeLogConfig;

typedef uint32_t KimeInputResult;
#define KimeInputResult_CONSUMED (uint32_t)1
#define KimeInputResult_LANGUAGE_CHANGED (uint32_t)2
#define KimeInputResult_HAS_PREEDIT (uint32_t)4
#define KimeInputResult_HAS_COMMIT (uint32_t)8
#define KimeInputResult_NOT_READY (uint32_t)16

typedef struct KimeRustStr {
  const uint8_t *ptr;
  uintptr_t len;
} KimeRustStr;

typedef uint32_t KimeModifierState;
#define KimeModifierState_SHIFT (uint32_t)1
#define KimeModifierState_CONTROL (uint32_t)2
#define KimeModifierState_SUPER (uint32_t)4
#define KimeModifierState_ALT (uint32_t)8

typedef struct KimeRustSlice {
  const uint8_t *ptr;
  uintptr_t len;
} KimeRustSlice;

typedef struct KimeFontData {
  struct KimeRustSlice font_data;
  uint32_t index;
  float size;
} KimeFontData;

/**
 * Return API version
 */
uintptr_t kime_api_version(void);

/**
 * Create new engine
 */
struct KimeInputEngine *kime_engine_new(const struct KimeConfig *config);

/**
 * Set hangul enable state
 */
void kime_engine_set_input_category(struct KimeInputEngine *engine, KimeInputCategory category);

/**
 * Delete engine
 *
 * # Safety
 *
 * engine must be created by `kime_engine_new` and never call delete more than once
 */
void kime_engine_delete(struct KimeInputEngine *engine);

/**
 * Check engine ready state
 */
bool kime_engine_check_ready(const struct KimeInputEngine *engine);

/**
 * End engine ready state
 */
KimeInputResult kime_engine_end_ready(struct KimeInputEngine *engine);

/**
 * Update layout state
 */
void kime_engine_update_layout_state(struct KimeInputEngine *engine);

/**
 * Get commit string of engine
 *
 * ## Return
 *
 * valid utf8 string
 */
struct KimeRustStr kime_engine_commit_str(const struct KimeInputEngine *engine);

/**
 * Get preedit string of engine
 *
 * ## Return
 *
 * valid utf8 string
 */
struct KimeRustStr kime_engine_preedit_str(struct KimeInputEngine *engine);

/**
 * Clear commit string
 */
void kime_engine_clear_commit(struct KimeInputEngine *engine);

/**
 * Clear preedit state this function may append to commit string
 */
void kime_engine_clear_preedit(struct KimeInputEngine *engine);

/**
 * Clear preedit state this function must not append to commit string
 */
void kime_engine_remove_preedit(struct KimeInputEngine *engine);

/**
 * Reset engine state
 */
void kime_engine_reset(struct KimeInputEngine *engine);

/**
 * Press key when modifier state
 *
 * ## Return
 *
 * input result
 */
KimeInputResult kime_engine_press_key(struct KimeInputEngine *engine,
                                      const struct KimeConfig *config,
                                      uint16_t hardware_code,
                                      bool numlock,
                                      KimeModifierState state);

/**
 * Load config from local file
 */
struct KimeConfig *kime_config_load(void);

/**
 * Create default config note that this function will not read config file
 */
struct KimeConfig *kime_config_default(void);

/**
 * Delete config
 */
void kime_config_delete(struct KimeConfig *config);

/**
 * Get candidate_font config
 * font_data only valid while config is live
 */
struct KimeFontData kime_config_candidate_font(const struct KimeConfig *config);

/**
 * Get xim_preedit_font config
 * font_data only valid while config is live
 */
struct KimeFontData kime_config_xim_preedit_font(const struct KimeConfig *config);

/**
 * Load daemon config
 */
struct KimeDaemonConfig *kime_daemon_config_load(void);

/**
 * Get daemon `modules`
 */
uint32_t kime_daemon_config_modules(const struct KimeDaemonConfig *config);

/**
 * Get default daemon config
 */
struct KimeDaemonConfig *kime_daemon_config_default(void);

/**
 * Delete daemon config
 */
void kime_daemon_config_delete(struct KimeDaemonConfig *config);

/**
 * Load indicator config
 */
struct KimeIndicatorConfig *kime_indicator_config_load(void);

/**
 * Get default indicator config
 */
struct KimeIndicatorConfig *kime_indicator_config_default(void);

/**
 * Delete indicator config
 */
void kime_indicator_config_delete(struct KimeIndicatorConfig *config);

/**
 * Get indicator `icon_color`
 */
enum KimeIconColor kime_indicator_config_icon_color(const struct KimeIndicatorConfig *config);

/**
 * Load log config
 */
struct KimeLogConfig *kime_log_config_load(void);

/**
 * Get default log config
 */
struct KimeLogConfig *kime_log_config_default(void);

/**
 * Delete log config
 */
void kime_log_config_delete(struct KimeLogConfig *config);

/**
 * Get log `icon_color`
 */
struct KimeRustStr kime_log_config_global_level(const struct KimeLogConfig *config);
