#pragma once

/* Generated with cbindgen:0.26.0 */

/* DO NOT MODIFY THIS MANUALLY */

#include <stdint.h>
#include <stddef.h>

namespace kime {

constexpr static const uintptr_t KIME_API_VERSION = 7;

enum class IconColor {
  White,
  Black,
};

enum class InputCategory : uint32_t {
  Latin,
  Hangul,
};

/// Preprocessed engine config
struct Config;

struct DaemonConfig;

struct IndicatorConfig;

struct InputEngine;

struct LogConfig;

using InputResult = uint32_t;
constexpr static const InputResult InputResult_CONSUMED = (uint32_t)1;
constexpr static const InputResult InputResult_LANGUAGE_CHANGED = (uint32_t)2;
constexpr static const InputResult InputResult_HAS_PREEDIT = (uint32_t)4;
constexpr static const InputResult InputResult_HAS_COMMIT = (uint32_t)8;
constexpr static const InputResult InputResult_NOT_READY = (uint32_t)16;

struct RustStr {
  const uint8_t *ptr;
  uintptr_t len;
};

using ModifierState = uint32_t;
constexpr static const ModifierState ModifierState_SHIFT = (uint32_t)1;
constexpr static const ModifierState ModifierState_CONTROL = (uint32_t)2;
constexpr static const ModifierState ModifierState_SUPER = (uint32_t)4;
constexpr static const ModifierState ModifierState_ALT = (uint32_t)8;

struct RustSlice {
  const uint8_t *ptr;
  uintptr_t len;
};

struct FontData {
  RustSlice font_data;
  uint32_t index;
  float size;
};

extern "C" {

/// Return API version
uintptr_t kime_api_version();

/// Create new engine
InputEngine *kime_engine_new(const Config *config);

/// Set hangul enable state
void kime_engine_set_input_category(InputEngine *engine, InputCategory category);

/// Delete engine
///
/// # Safety
///
/// engine must be created by `kime_engine_new` and never call delete more than once
void kime_engine_delete(InputEngine *engine);

/// Check engine ready state
bool kime_engine_check_ready(const InputEngine *engine);

/// End engine ready state
InputResult kime_engine_end_ready(InputEngine *engine);

/// Update layout state
void kime_engine_update_layout_state(InputEngine *engine);

/// Get commit string of engine
///
/// ## Return
///
/// valid utf8 string
RustStr kime_engine_commit_str(const InputEngine *engine);

/// Get preedit string of engine
///
/// ## Return
///
/// valid utf8 string
RustStr kime_engine_preedit_str(InputEngine *engine);

/// Clear commit string
void kime_engine_clear_commit(InputEngine *engine);

/// Clear preedit state this function may append to commit string
void kime_engine_clear_preedit(InputEngine *engine);

/// Clear preedit state this function must not append to commit string
void kime_engine_remove_preedit(InputEngine *engine);

/// Reset engine state
void kime_engine_reset(InputEngine *engine);

/// Press key when modifier state
///
/// ## Return
///
/// input result
InputResult kime_engine_press_key(InputEngine *engine,
                                  const Config *config,
                                  uint16_t hardware_code,
                                  bool numlock,
                                  ModifierState state);

/// Load config from local file
Config *kime_config_load();

/// Create default config note that this function will not read config file
Config *kime_config_default();

/// Delete config
void kime_config_delete(Config *config);

/// Get candidate_font config
/// font_data only valid while config is live
FontData kime_config_candidate_font(const Config *config);

/// Get xim_preedit_font config
/// font_data only valid while config is live
FontData kime_config_xim_preedit_font(const Config *config);

/// Load daemon config
DaemonConfig *kime_daemon_config_load();

/// Get daemon `modules`
uint32_t kime_daemon_config_modules(const DaemonConfig *config);

/// Get default daemon config
DaemonConfig *kime_daemon_config_default();

/// Delete daemon config
void kime_daemon_config_delete(DaemonConfig *config);

/// Load indicator config
IndicatorConfig *kime_indicator_config_load();

/// Get default indicator config
IndicatorConfig *kime_indicator_config_default();

/// Delete indicator config
void kime_indicator_config_delete(IndicatorConfig *config);

/// Get indicator `icon_color`
IconColor kime_indicator_config_icon_color(const IndicatorConfig *config);

/// Load log config
LogConfig *kime_log_config_load();

/// Get default log config
LogConfig *kime_log_config_default();

/// Delete log config
void kime_log_config_delete(LogConfig *config);

/// Get log `icon_color`
RustStr kime_log_config_global_level(const LogConfig *config);

} // extern "C"

} // namespace kime
